/*
 * The RangeIterator class iterates through a range specified by the user, with an optional step
 * size. By default, this step size is 1.
 */

#if !defined(PIF_NOPREFIX_GENERAL) && !defined(PIF_NOPREFIX_ITERATOR)
pif_Iterator/RangeIterator
#else
Iterator/RangeIterator
#endif
	var
		start = null
		end = null

		step_size = null
		count = null

	proc
		_MaxCount()
			return round(abs((start - end) / step_size))

	/*
	 * Protocol implementation.
	 */

	New(_start, _end, _step_size = 1)
		start = _start
		end = _end

		step_size = _step_size
		if(step_size == 0)
#if !defined(PIF_NOPREFIX_GENERAL) && !defined(PIF_NOPREFIX_ITERATOR)
			throw EXCEPTION("step_size for /pif_Iterator/RangeIterator must be non-zero.")
#else
			throw EXCEPTION("step_size for /Iterator/RangeIterator must be non-zero.")
#endif
		else if(
			( (start <= end) && (step_size < 0) ) || \
			( (end < start) && (step_size > 0) ) \
		)
			step_size = -step_size
		return 1

	Initialize()
		count = 0
		return 1

	Next()
		if(Done())
			return 0
		else
			count ++
			return Position()

	Look()
		if(Done(Position() - 1))
			return null
		else
			return start + (Position() - 1) * step_size

	Done(p = Position())
		return (p - 1) >= _MaxCount()

	Position()
		return count + 1